// This is part of SubmitFile
// Visit: http://www.pdfhacks.com/print_pdf/
// Copyright (c) 2003 O'Reilly and Associates

#include <windows.h>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <string>
#include <wininet.h>

using namespace std;

static bool
Upload( HINTERNET hRequest, 
	const string& field_name,
	const string& field_filename,
	const string& response_filename )
{
  bool ret_val_b= true; // reset on error

  // debug
  //ofstream testFile( "c:\\testpage.copy.ps", ios_base::binary );
 
  if( true /*testFile*/) {
    // TODO: repace with date or something
    string sBoundary= "-----------------------41184";

    string fieldDataDelimOpen= 
      "--"+ sBoundary+
      "\r\nContent-Disposition: form-data; name=\""+ field_name+ 
      "\"; filename=\""+ field_filename+ 
      "\"\r\nContent-Type: application/postscript\r\n\r\n";
    string fieldDataDelimClose= "\r\n--"+ sBoundary+ "--\r\n";

    unsigned long file_len= 0; {
      ifstream fieldFile( field_filename.c_str(), ios_base::binary );
      while( fieldFile.ignore() ) ++file_len;
      --file_len;
    }
    unsigned long request_len= file_len+
      fieldDataDelimOpen.length()+ fieldDataDelimClose.length();
    char request_len_s[128]= "";
    itoa( request_len, request_len_s, 10 );

    string sHeader= "Content-Type: multipart/form-data; boundary="+ sBoundary+ 
      "\r\nContent-Length: "+ request_len_s+ "\r\n";

    if( HttpAddRequestHeaders( hRequest, 
			       sHeader.c_str(), 
			       sHeader.length(), 
			       0 ) )
      {
	//testFile << sHeader; // debug

	if( HttpSendRequestEx(hRequest, /*&InBuf*/ 0, 0, HSR_INITIATE, 0) ) {
	  unsigned long ulWrote;
	  bool bWrote= true;

	  // open
	  bWrote= 
	    InternetWriteFile( hRequest, 
			       (const void*)fieldDataDelimOpen.c_str(), 
			       fieldDataDelimOpen.length(), 
			       &ulWrote );
	  //testFile << fieldDataDelimOpen; // debug

	  // data
	  unsigned long file_written= 0;
	  ifstream fieldFile( field_filename.c_str(), ios_base::binary );
	  char buff[2048];
	  while( fieldFile ) {
	    fieldFile.read( buff, 2048 );
	    InternetWriteFile( hRequest,
			       buff,
			       fieldFile.gcount(),
			       &ulWrote );
	    //testFile.write( buff, fieldFile.gcount() ); // debug
	  }
	  fieldFile.close();

	  // close
	  bWrote&= 
	    InternetWriteFile( hRequest, 
			       (const void*)fieldDataDelimClose.c_str(), 
			       fieldDataDelimClose.length(), 
			       &ulWrote );
	  //testFile << fieldDataDelimClose; // debug

	  //
	  bWrote&= HttpEndRequest(hRequest, 0, HSR_INITIATE, 0 );

	  if(!bWrote) {
	    cerr << "bWrote== false" << endl;
	  }
	  else {
	    ofstream response( response_filename.c_str(), ios_base::binary );
	    char Buffer[4096]= { 0 };
	    while( InternetReadFile( hRequest, 
				     Buffer, 
				     4095, 
				     &ulWrote) && 
		   ulWrote > 0 )
	      {
		response.write( Buffer, ulWrote );
	      }
	  }
	}
	else { // error
	  cerr << "Error: HttpSendRequestEx() failed" << endl;
	  ret_val_b= false;
	}
      }
    else { // error
      cerr << "Error: HttpAddHeadersRequest() failed" << endl;
      ret_val_b= false;
    }
  }
  else { // error
    cerr << "Error: could not open output testfile" << endl;
    ret_val_b= false;
  }

  //testFile.close();

  return ret_val_b;
}

static bool 
Post( const string& sUrl, 
      const string& sServer, 
      unsigned short nPort,
      const string& field_name,
      const string& field_filename,
      const string& response_filename )
{
  bool ret_val_b= true;

  if( nPort== 0 )
    nPort= 80;

  HINTERNET hOpen= 
    InternetOpen( "Mozilla", // user agent (TODO)
		  INTERNET_OPEN_TYPE_PRECONFIG, 
		  0, 0, // proxy name, proxy bypass
		  0 ); // flags

  if( hOpen ) {
    HINTERNET hConnect= 
      InternetConnect( hOpen, 
		       sServer.c_str(), // server name, e.g. "www.accesspdf.com"
		       INTERNET_DEFAULT_HTTP_PORT, 
		       "", // username
		       "", // password
		       INTERNET_SERVICE_HTTP, 
		       0, // flags
		       0 ); // context

    if( hConnect ) {
      LPCTSTR AcceptTypes[2]= { 0 };
      TCHAR szAccept[]= TEXT("*/*");
      AcceptTypes[0]= szAccept;

      HINTERNET hRequest= 
	HttpOpenRequest( hConnect, 
			 TEXT("POST"), 
			 sUrl.c_str(), // object name
			 HTTP_VERSION, 
			 TEXT(""), // referrer
			 AcceptTypes, // acceptable return types
			 0, // flags
			 0 ); // connection

      if( hRequest ) {

	// test
	if( !Upload( hRequest, 
		     field_name, 
		     field_filename, 
		     response_filename ) )
	  {
	    cerr << "ERROR: Upload() failed" << endl;
	    ret_val_b= false;
	  }

	InternetCloseHandle( hRequest );
	hRequest= 0;
      }
      else { // error
	cerr << "ERROR: hRequest invalid" << endl;
	ret_val_b= false;
      }

      InternetCloseHandle( hConnect );
      hConnect= 0;
    }
    else { // error
      cerr << "ERROR: hConnect invalid" << endl;
      ret_val_b= false;
    }

    InternetCloseHandle( hOpen );
    hOpen= 0;
  }
  else { // error
    cerr << "ERROR: hOpen invalid" << endl;
    ret_val_b= false;
  }

  return ret_val_b;
}

int main( int argc, char** argv )
{
  cerr << "SubmitFile" << endl;
  cerr << "Copyright (c) 2003 O'Reilly and Associates" << endl;
  cerr << "   Received " << argc- 1 << " arguments: " << endl;
  for( int ii= 1; ii< argc; ++ii ) {
    cerr << "      " << argv[ii] << endl;
  }

  if( argc== 5 ) {
    string path= argv[1];//"/convert/convert.cgi";
    string server= argv[2];//"www.ps2pdf.com";
    string field_name= argv[3];//"inputfile";
    string field_filename= argv[4];
    string response_filename= field_filename+ ".html";

  cerr << "Arguments: " << endl;
  cerr << "   CGI Path on Server: " << path << endl;
  cerr << "   CGI Server: " << server << endl;
  cerr << "   Field Name: " << field_name << endl;
  cerr << "   Field File Name (uploaded): " << field_filename << endl;
  cerr << "   Response File Name: " << response_filename << endl;

  if( !path.empty() && 
      !server.empty() && 
      !field_name.empty() &&
      !field_filename.empty() )
    {
      cerr << "Posting..." << endl;
      if( Post( path, 
		server, 
		80,
		field_name,
		field_filename,
		response_filename ) ) 
	{
	  cerr << "Launching Response..." << endl;

	  ShellExecute( 0, // hWND
			"open",
			response_filename.c_str(),
			0,
			0,
			SW_SHOWNORMAL );
	}
      else { // error
	cerr << "Error: Post() failed" << endl;
      }
    }
  else { // error
      cerr << "Required Parameters Missing; No Post Made" << endl;
    }
  }
  else { // error
    cerr << "Error: Need 4 arguments:" << endl;
    cerr << "   SubmitFile <CGI Path> <CGI Server> <form field name> <local filename to submit>" << endl;
  }

  return 0;
}
